// Varying in
varying highp vec4 var_position;
varying highp vec3 var_normal;
varying highp vec2 var_texcoord0;

// Uniforms
uniform highp mat4 world_view;
uniform highp sampler2D tex0;
uniform highp vec4 light;

void main() {

    vec3 e = normalize( vec3(0.0, 0.0, -90.0) );
    vec3 n = normalize( world_view * vec4(var_normal, 0.0) ).xyz;
    vec3 r = reflect( e, n );
    
    float m = 2. * sqrt(
        pow( r.x, 2.0 ) +
        pow( r.y, 2.0 ) +
        pow( r.z + 1.0, 2.0 )
    );
    vec2 vN = r.xy / m + 0.5;

    vec3 base = texture2D( tex0, vN).rgb;

    gl_FragColor = vec4( base, 1.0 ); // gl_FragColor out

}
